﻿; http://ahkscript.org/germans/forums/viewtopic.php?t=6803
; Klavier Hero by Bentschi
; Modified version to support AHK v1.1 x32 Unicode and US keyboard
; Modified again by Drugwash to use scan codes and proper data types
; (best viewed with Tahoma 9pt font and tabstops set at 4 chars)

#NoEnv
#SingleInstance force
#WinActivateForce
SetTitleMatchMode, 2
SetBatchLines, -1
SetWinDelay, -1
SetControlDelay, -1
SetKeyDelay, -1, -1
SetMouseDelay, -1
ListLines, Off
SetFormat, Integer, D
SetWorkingDir, %A_ScriptDir%
DetectHiddenWindows, On

AW			:= A_IsUnicode ? "W" : "A"
A_CharSize	:= A_IsUnicode ? 2 : 1
SWL			:= "user32\SetWindowLong" (A_PtrSize=8 ? "Ptr" : "") AW
SetVars		:= "MainX,MainY,MainW,MainH,KbdX,KbdY,KbdW,KbdH
					,Instrument,Device,Vol,Vel,Octave,Channel,DrawMode,Layout"
IniFile			:= A_ScriptDir "\Klavier hero.ini"
Vol			:= 85		; [%] Initial volume
Vel			:= 50		; [%] Initial velocity
Device		:= 1		; 1=Default
Instrument	:= 1		; [1-128] Default instrument
Channel		:= 1		; [1-16] Default channel
Octave		:= 1		; [-2-4] Default octave
MainX			:= 100	; [px] Default main window horizontal position
MainY		:= 100	; [px] Default main window vertical position
MainW		:= 500
MainH		:= 500
KbdX			:= 40		; [px] Default keyboard horizontal position
KbdY			:= 600	; [px] Default keyboard vertical position
KbdW		:= 400	; [px] Default keyboard width
KbdH			:= 80		; [px] Default keyboard height
DrawMode	:= 1		; [0-1] Initial drawing mode (1=OpenGL)

appname	:= "Klavier hero 2018"
version		:= "1.2.6.0"

Menu, Tray, Tip, %appname% v%version%
Loop, Parse, SetVars, CSV
	IniRead, %A_LooPField%, %IniFile%, Settings, %A_LoopField%, % %A_LoopField%
Loop, 128
	{
	IniRead, i, %IniFile%, Instruments, %A_Index%, <???>
	Instruments .= A_Index A_Tab i "|"
	}
Loop, 7
	IniRead, DevType%A_Index%, %IniFile%, DevTypes, %A_Index%, %A_Index%
StringTrimRight, Instruments, Instruments, 1
charL := Asc("A"), charH := Asc("Z"), charR := charH - charL + 1
HotkeysLine1 := "56,1E,2C,1F,2D,20,2E,2F,22,30,23,31,32,25,33,26,34,27,35"
HotkeysLine2 := "10,03,11,04,12,13,06,14,07,15,08,16,17,0A,18,0B,19,1A,0D,1B"
Hotkeys := HotkeysLine1 "," HotkeysLine2
Loop, Parse, Hotkeys, CSV
	{
	sc := "0x" A_Loopfield, sc+=0
	Key%sc% := A_Index, MKey%A_Index% := sc
	NumKeys := A_Index
	}
LayoutList := LayoutList(ByRef listHKL)
hWinMM := DllCall("kernel32\LoadLibrary" AW, "Str", "Winmm.dll", "Ptr")
NumDevs := DllCall("Winmm\midiOutGetNumDevs"), DCsz := 20+32*A_CharSize
Loop, % NumDevs
	{
	VarSetCapacity(DevCaps, DCsz, 0)
	DllCall("Winmm\midiOutGetDevCaps" AW, "UInt", A_Index-1, "Ptr", &DevCaps, "UInt", DCsz)
	Name := StrGet(&DevCaps+8)
	DevName%A_Index% := Name
	DevNames .= Name "|"
	}
StringTrimRight, DevNames, DevNames, 1
VarSetCapacity(DevCaps, 0), VarSetCapacity(Name, 0)
VarSetCapacity(HotkeysLine1, 0), VarSetCapacity(HotkeysLine2, 0)
Volume := Round(Vol*127/100)

Gui, Add, DDL, x-200 y-200 w0 h0 vFocusButton
Gui, Add, Text, x10 y10 cBlue, Instrument:
Gui, Add, ListBox, xp y+3 w200 h450 +0x80 +AltSubmit +hwndhInstList gChooseInstr vList,
VarSetCapacity(tabs, 4, 0), NumPut(16, tabs, 0, "UInt")
SendMessage, 0x192, 1, &tabs,, ahk_id %hInstList%	; LB_SETTABSTOPS
;GuiControl,, List, % Instruments
;GuiControl, Choose, List, % Instrument
Gui, Add, Text, x+10 y10 cBlue, MIDI Device:
Gui, Add, DDL, xp y+3 w220 +AltSubmit Section vDev gChooseDev, % DevNames
Gui, Add, Text, xp y+5 w50 cBlue, Type:
Gui, Add, Text, x+1 yp w170 vDeviceT,
Gui, Add, Text, xs y+5 w50 cBlue, ID:
Gui, Add, Text, x+1 yp w170 vDeviceI,
Gui, Add, Text, xs y+5 cBlue, Channels:
Gui, Add, Text, x+1 yp w25 vDeviceC,
Gui, Add, Text, x+5 yp cBlue, Voices:
Gui, Add, Text, x+1 yp w25 vDeviceV,
Gui, Add, Text, x+5 yp cBlue, Notes:
Gui, Add, Text, x+1 yp w25 vDeviceN,

Gui, Add, Text, xs y+15 w50 cBlue vVolLabel, Volume:
Gui, Add, Text, x+1 yp w35 vVolVal, %Vol% `%
Gui, Add, Slider, xs y+3 w220 hwndhVol vVol gChooseVol +0x100 AltSubmit Range0-100 TickInterval25
	, % Vol
Gui, Add, Text, xs y+15 w50 cBlue vVelLabel, Velocity:
Gui, Add, Text, x+1 yp w35 vVelVal, %Vel% `%
Gui, Add, Slider, xs y+3 w220 hwndhVel vVel gChooseVel +0x100 AltSubmit Range0-100 TickInterval25
	, % Vel
Gui, Add, Text, xp y+10 cBlue Section, Octave:
Gui, Add, Edit, x+2 yp-4 w40
Gui, Add, UpDown, Range-2-4 vOctave gChooseOctave, % Octave
Gui, Add, Text, x+10 ys cBlue, Channel:
Gui, Add, DDL, x+2 yp-4 w85 +Altsubmit vChannel gChooseChannel
	, 1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16
GuiControl, Choose, Dev, % Device
GuiControlGet, ch, Pos, Channel
Gui, Add, Text, xs y+15 cBlue, Virtual keyboard display:
Gui, Add, DDL, x%chX% yp-4 w85 +AltSubmit vDrawMode gChooseDrawMode, [Hidden]|OpenGL
GuiControl, Choose, DrawMode, % DrawMode+1
Gui, Add, Text, xs y+10 cBlue, Physical keyboard layout:
Gui, Add, DDL, xp y+3 w220 R30 +AltSubmit -Disabled vLayout gChooseLayout, % LayoutList
GuiControl, Choose, Layout, % Layout
Gui +LastFound
hWnd := WinExist()
Gui, Show, Hide w%MainW% h%MainH%, %appname% v%version%
SetWndPos(hWnd, MainX, MainY, MainW, MainH)

hWP1 := RegisterCallback("WndProc", "F", 4, 0)
midiOutShortMsg := DllCall("kernel32\GetProcAddress", "Ptr", hWinMM, "AStr", "midiOutShortMsg", "Ptr")
GoSub, ChooseDev
Gui, Show, AutoSize
OnExit, GuiClose
OnMessage(0x100, "PlayTone", 10)		; WM_KEYDOWN
OnMessage(0x101, "ReleaseTone", 10)	; WM_KEYUP
OnMessage(0x201, "MouseClick")			; WM_LBUTTONDOWN
OnMessage(0x203, "MouseClick")			; WM_LBUTTONDBLCLK
OnMessage(0x202, "MouseRelease")		; WM_LBUTTONUP
OnMessage(0x20A, "MWheel")				; WM_MOUSEWHEEL
OnMessage(0xA4, "HideKeys")				; WM_NCRBUTTONDOWN
GoSub, EnableDraw
Return
;================================================================
ChooseDev:
GuiControlGet, Device,, Dev
VarSetCapacity(DevCaps, DCsz, 0)
DllCall("Winmm\midiOutGetDevCaps" AW, "UInt", Device-1, "Ptr", &DevCaps, "UInt", DCsz)
i1 := Format("{:04x}", NumGet(DevCaps, 0, "UShort"))
i2 := Format("{:04x}", NumGet(DevCaps, 2, "UShort"))
DevID		:= "MID_" i1 "   PID_" i2
DevType	:= NumGet(DevCaps, 8+32*A_CharSize, "UShort")
DevVoices	:= NumGet(DevCaps, 10+32*A_CharSize, "UShort")
DevNotes	:= NumGet(DevCaps, 12+32*A_CharSize, "UShort")
DevChan	:= NumGet(DevCaps, 14+32*A_CharSize, "UShort")
DevChan	:= DevChan != 0xFFFF ? DevChan : 16
DevOpt		:= NumGet(DevCaps, 16+32*A_CharSize, "UInt")
GuiControl,, DeviceT, % DevType%DevType%
GuiControl,, DeviceV, %DevVoices%
GuiControl,, DeviceN, %DevNotes%
GuiControl,, DeviceC, %DevChan%
GuiControl,, DeviceI, %DevID%
NoVol := !(DevOpt & 0x1)	; MIDICAPS_VOLUME
GuiControl, % (NoVol ? "Disable" : "Enable"), VolLabel
GuiControl, % (NoVol ? "Disable" : "Enable"), VolVal
GuiControl, % (NoVol ? "Disable" : "Enable"), Vol
GuiControl,, Channel, |
Loop, % DevChan
	If A_Index!=10
		GuiControl,, Channel, %A_Index% (generic)
	Else GuiControl,, Channel, 10 (percuss.)
Channel := Channel > DevChan ? 1 : Channel
GuiControl, Choose, Channel, % Channel
GoSub InitMidi
; if volume available, get current values before any changes and restore them on device close
If !NoVol
	DllCall("Winmm\midiOutGetVolume", "Ptr", hMidiOut, "UIntP", PDevVol)
Else PDevVol := ""
GoSub ChooseChannel
;GoSub ChooseInstr
GoSub ChooseVel
;Return
;================================================================
ChooseVol:
GuiControlGet, Vol
Volume := Round(Vol*0xFFFF/100)
GuiControl,, VolVal, %Vol% `%
DllCall("Winmm\midiOutSetVolume", "Ptr", hMidiOut, "UInt", (Volume | Volume << 16)) ; device volume
Return
;================================================================
ChooseVel:
GuiControlGet, Vel
Velocity := Round(Vel*127/100)
GuiControl,, VelVal, %Vel% `%
Return
;================================================================
ChooseChannel:
GuiControlGet, Channel
If (Channel=LastChannel)
	Return
If Channel=10		; Percussions only
	{
	If !oInstrument
		oInstrument := Instrument
	Instrument:=1	; 9,17,25,26,33,41,49,57
	GuiControl,, List, |Percussions only
	}
Else
	{
	If (!LastChannel OR LastChannel=10)	; only refresh the list when necessary
		GuiControl,, List, |%Instruments%
	If oInstrument
		Instrument := oInstrument, oInstrument := 0
	GuiControl, Choose, List, %Instrument%
	}
GoSub ChooseInstr
LastChannel := Channel
Return
;================================================================
ChooseInstr:
GuiControlGet, Instrument,, List
i := Instrument-1
DllCall(midiOutShortMsg, "Ptr", hMidiOut, "UInt", (i<<8) + Channel+191)
Return
;================================================================
ChooseOctave:
GuiControlGet, Octave
Return
;================================================================
ChooseLayout:
GuiControlGet, Layout
DrawMode:=1
GoSub EnableDraw
Return
;================================================================
InitMidi:
If (Device > NumDevs)
  Device := 1
If (hMidiOut)
  GoSub, FreeMidi
VarSetCapacity(hMidiOut, A_PtrSize, 0)
DllCall("Winmm\midiOutOpen", "PtrP", hMidiOut, "UInt", Device-1, "Ptr", 0, "Ptr", 0, "UInt", 0)
Return
;================================================================
FreeMidi:
If (PDevVol != "")
	DllCall("Winmm\midiOutSetVolume", "Ptr", hMidiOut, "UInt", PDevVol) ; restore device volume
DllCall("Winmm\midiOutReset", "Ptr", hMidiOut)
DllCall("Winmm\midiOutClose", "Ptr", hMidiOut)
Return
;================================================================
GuiClose:
Critical
GetWndPos(hWnd, MainX, MainY, MainW, MainH)
GoSub, DisableDraw
GoSub, FreeMidi
DllCall("kernel32\FreeLibrary", "Ptr", hWinMM)
Loop, Parse, SetVars, CSV
	IniWrite, % %A_LooPField%, %IniFile%, Settings, %A_LoopField%
ExitApp
;================================================================
ChooseDrawMode:
GuiControlGet, DrawMode
DrawMode--

EnableDraw:
If DrawModeInit
  GoSub, DisableDraw
If !DrawMode
	Return
Gui, 2: +LastFound -SysMenu +ToolWindow +E0x40000 +Resize +MinSize200x50 -DPIscale
hWnd2 := WinExist()
hWP := DllCall(SWL
	, "Ptr", hWnd2
	, "Int", -4	; GWL_WNDPROC
	, "Ptr", hWP1
	, "Ptr")
If DrawMode=1
  GoTo, InitOpenGL
Return
;================================================================
2GuiClose:
GuiControl, 1:Choose, DrawMode, 1

DisableDraw:
Critical
GetWndPos(hWnd2, KbdX, KbdY, KbdW, KbdH)
Gui, 2:Hide
If DrawModeInit
	{
	DllCall("opengl32\wglMakeCurrent", "Ptr", 0, "Ptr", 0)
	DllCall("opengl32\wglDeleteContext", "Ptr", hRC)
	DllCall("gdi32\SelectObject", "Ptr", hDC, "Ptr", hOFont)
	DllCall("user32\ReleaseDC", "Ptr", hWnd2, "Ptr", hDC)
	DllCall("gdi32\DeleteObject", "Ptr", hFont)
	DllCall("kernel32\FreeLibrary", "Ptr", hOpenGL)
	DllCall("kernel32\FreeLibrary", "Ptr", hGdi32)
	DllCall(SWL
		, "Ptr", hWnd2
		, "Int", -4	; GWL_WNDPROC
		, "Ptr", hWP
		, "Ptr")
	Gui, 2:Destroy
	}
DrawModeInit := 0
Return
;================================================================
2GuiSize:
KbdW := A_GuiWidth, KbdH := A_GuiHeight
GetClientSz(hWnd2, KbdCW, KbdCH)
; Gosub UpdateOpenGL	; hangs the script
; WinSet, Redraw,, ahk_id %hWnd2%	; flickers badly on resize
; DllCall("user32\UpdateWindow", "Ptr", hWnd2) ; doesn't flicker but lags, no update on downsizing
DllCall("user32\RedrawWindow", "Ptr", hWnd2, "Ptr", 0, "Ptr", 0, "UInt", 0x143)
; RDW_UPDATENOW=0x100
; RDW_NOCHILDREN=0x40
; RDW_INTERNALPAINT=0x2
; RDW_INVALIDATE=0x1
SetTimer, GetWndPosLabel, -100
Return
;================================================================
GetWndPosLabel:
GetWndPos(hWnd2, KbdX, KbdY, KbdW, KbdH)
GetClientSz(hWnd2, KbdCW, KbdCH)
Return
;================================================================
GetWndPos(hwnd, ByRef x, ByRef y, ByRef w, ByRef h)
{
Static sz:=40+A_PtrSize
If !WinExist("ahk_id " hwnd)
	Return
VarSetCapacity(WP, sz, 0)	; WINDOWPLACEMENT struct
NumPut(sz, WP, 0, "UInt")
If !DllCall("user32\GetWindowPlacement", "Ptr", hwnd, "Ptr", &WP)
	Return
;c := NumGet(WP, 8, "UInt")	; 6=SW_MINIMIZE, 0=SW_HIDE
x := NumGet(WP, 24+A_PtrSize, "Int"), y := NumGet(WP, 28+A_PtrSize, "Int")
w := NumGet(WP, 32+A_PtrSize, "Int")-x, h := NumGet(WP, 36+A_PtrSize, "Int")-y
}
;================================================================
SetWndPos(hwnd, x, y, w, h)
{
Static sz:=40+A_PtrSize
VarSetCapacity(WP, sz, 0)	; WINDOWPLACEMENT struct
NumPut(sz, WP, 0, "UInt"), NumPut(1, WP, 8, "UInt")	; SW_SHOWNORMAL
NumPut(x, WP, 24+A_PtrSize, "Int"), NumPut(y, WP, 28+A_PtrSize, "Int")
NumPut(w+x, WP, 32+A_PtrSize, "Int"), NumPut(h+y, WP, 36+A_PtrSize, "Int")
Return DllCall("user32\SetWindowPlacement", "Ptr", hwnd, "Ptr", &WP)
}
;================================================================
GetClientSz(hwnd, ByRef w, ByRef h)
{
VarSetCapacity(RECT, 16, 0)
DllCall("user32\GetClientRect", "Ptr", hwnd, "Ptr", &RECT)
w := NumGet(RECT, 8, "UInt"), h := NumGet(RECT, 12, "UInt")
}
;================================================================
InitOpenGL:
DrawModeInit := 1
hOpenGL		:= DllCall("kernel32\LoadLibrary" AW, "Str", "opengl32.dll", "Ptr")
hGdi32			:= DllCall("kernel32\LoadLibrary" AW, "Str", "gdi32.dll", "Ptr")
hDC				:= DllCall("user32\GetDC", "Ptr", hWnd2, "Ptr")
VarSetCapacity(pfd, 40, 0)		; PIXELFORMATDESCRIPTOR struct
NumPut(40, pfd, 0, "UShort")	; nSize
NumPut(1, pfd, 2, "UShort")		; nVersion
NumPut(0x25, pfd, 4, "UInt")	; PFD_SUPPORT_OPENGL/DRAW_TO_WINDOW/DOUBLEBUFFER
NumPut(0, pfd, 8, "UChar")		; iPixelType PFD_TYPE_RGBA
NumPut(32, pfd, 9, "UChar")		; cColorBits
NumPut(16, pfd, 23, "UChar")	; cDepthBits
NumPut(0, pfd, 26, "UChar")		; iLayerType
PixelFormat		:= DllCall("gdi32\ChoosePixelFormat", "Ptr", hDC, "Ptr", &pfd)
DllCall("gdi32\SetPixelFormat", "Ptr", hDC, "UInt", PixelFormat, "Ptr", &pfd)
hRC				:= DllCall("opengl32\wglCreateContext", "Ptr", hDC, "Ptr")
DllCall("opengl32\wglMakeCurrent", "Ptr", hDC, "Ptr", hRC)
SwapBuffers	:= DllCall("kernel32\GetProcAddress", "Ptr", hGdi32   , "AStr", "SwapBuffers"	, "Ptr")
glClear			:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glClear"			, "Ptr")
glViewport		:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glViewport"		, "Ptr")
glMatrixMode	:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glMatrixMode"	, "Ptr")
glLoadIdentity	:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glLoadIdentity", "Ptr")
glOrtho			:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glOrtho"			, "Ptr")
glColor4f			:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glColor4f"		, "Ptr")
glRotatef		:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glRotatef"		, "Ptr")
glScalef			:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glScalef"			, "Ptr")
glTranslatef		:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glTranslatef"	, "Ptr")
glVertex2f		:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glVertex2f"		, "Ptr")
glPushMatrix	:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glPushMatrix"	, "Ptr")
glPopMatrix		:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glPopMatrix"		, "Ptr")
glEnable			:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glEnable"			, "Ptr")
glDisable			:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glDisable"			, "Ptr")
glBegin			:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glBegin"			, "Ptr")
glEnd				:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glEnd"				, "Ptr")
glGenLists		:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glGenLists"		, "Ptr")
glNewList		:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glNewList"		, "Ptr")
glCallList			:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glCallList"			, "Ptr")
glEndList		:= DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glEndList"		, "Ptr")

GL_BLEND								:= 0x0BE2
GL_COLOR_BUFFER_BIT			:= 0x00004000
GL_COMPILE							:= 0x1300
GL_LINE_LOOP						:= 0x0002
GL_LINE_SMOOTH					:= 0x0B20
GL_MODELVIEW						:= 0x1700
GL_ONE_MINUS_SRC_ALPHA	:= 0x0303
GL_PROJECTION						:= 0x1701
GL_QUADS								:= 0x0007
GL_SRC_ALPHA						:= 0x0302
GL_TRIANGLES						:= 0x0004

DllCall("opengl32\glBlendFunc", "UInt", GL_SRC_ALPHA, "UInt", GL_ONE_MINUS_SRC_ALPHA)

NumWKeys := 0, Index := 1
Loop, % NumKeys
	{
	If Index in 1,3,5,7,8,10,12
		NumWKeys++
	Index++
	If Index > 12
		Index := 1
	}
KeyWW := 100/NumWKeys, KeyBW := KeyWW/4*2.5, KeyC := 5
KeyBW2 := KeyBW/2, KeyBW4 := KeyBW/4, KeyW8 := KeyWW*0.8
List := DllCall(glGenLists, "UInt", 6)
DllCall(glNewList, "UInt", List+0, "UInt", GL_COMPILE)
DllCall(glLoadIdentity)
DllCall(glColor4f, "Float", 0, "Float", 0, "Float", 0, "Float", 1)
DllCall(glBegin, "UInt", GL_LINE_LOOP)
DllCall(glVertex2f, "Float", 0.001, "Float", 0.001)
DllCall(glVertex2f, "Float", 0.001, "Float", 9.999)
DllCall(glVertex2f, "Float", 99.999, "Float", 9.999)
DllCall(glVertex2f, "Float", 99.999, "Float", 0.001)
DllCall(glEnd)
DllCall(glEndList)

DllCall(glNewList, "UInt", List+1, "UInt", GL_COMPILE)
DllCall(glBegin, "UInt", GL_QUADS)
DllCall(glColor4f, "Float", 0.5, "Float", 0.5, "Float", 0.5, "Float", 1)
DllCall(glVertex2f, "Float", 0, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 0)
DllCall(glColor4f, "Float", 1, "Float", 1, "Float", 1, "Float", 1)
DllCall(glVertex2f, "Float", KeyWW, "Float", 1)
DllCall(glVertex2f, "Float", 0, "Float", 1)
DllCall(glVertex2f, "Float", 0, "Float", 1)
DllCall(glVertex2f, "Float", KeyWW, "Float", 1)
DllCall(glVertex2f, "Float", KeyWW, "Float", 9.6)
DllCall(glVertex2f, "Float", 0, "Float", 9.6)
DllCall(glEnd)
DllCall(glColor4f, "Float", 0, "Float", 0, "Float", 0, "Float", 1)
DllCall(glBegin, "UInt", GL_LINE_LOOP)
DllCall(glVertex2f, "Float", 0, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 9.6)
DllCall(glVertex2f, "Float", 0, "Float", 9.6)
DllCall(glEnd)
DllCall(glTranslatef, "Float", KeyWW, "Float", 0, "Float", 0)
DllCall(glEndList)

DllCall(glNewList, "UInt", List+2, "UInt", GL_COMPILE)
DllCall(glTranslatef, "Float", KeyWW, "Float", 0, "Float", 0)
DllCall(glBegin, "UInt", GL_QUADS)
DllCall(glColor4f, "Float", 0.15, "Float", 0.15, "Float", 0.15, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 10/4*2.5)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 10/4*2.5)
DllCall(glColor4f, "Float", 0.2, "Float", 0.2, "Float", 0.2, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 0.5)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 0.5)
DllCall(glColor4f, "Float", 0.5, "Float", 0.5, "Float", 0.5, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 10/4*2.0)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 10/4*2.0)
DllCall(glColor4f, "Float", 0.2, "Float", 0.2, "Float", 0.2, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 0.5)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 0.5)
DllCall(glColor4f, "Float", 0.5, "Float", 0.5, "Float", 0.5, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 0)
DllCall(glColor4f, "Float", 0.3, "Float", 0.3, "Float", 0.3, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 10/4*2.0)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 10/4*2.0)
DllCall(glColor4f, "Float", 0.2, "Float", 0.2, "Float", 0.2, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 10/4*2.5)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 10/4*2.5)
DllCall(glEnd)
DllCall(glEndList)

DllCall(glNewList, "UInt", List+3, "UInt", GL_COMPILE)
DllCall(glBegin, "UInt", GL_QUADS)
DllCall(glColor4f, "Float", 0.4, "Float", 0.4, "Float", 0.4, "Float", 1)
DllCall(glVertex2f, "Float", 0, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 0)
DllCall(glColor4f, "Float", 0.9, "Float", 0.9, "Float", 0.9, "Float", 1)
DllCall(glVertex2f, "Float", KeyWW, "Float", 1.5)
DllCall(glVertex2f, "Float", 0, "Float", 1.5)
DllCall(glVertex2f, "Float", 0, "Float", 1.5)
DllCall(glVertex2f, "Float", KeyWW, "Float", 1.5)
DllCall(glColor4f, "Float", 0.7, "Float", 0.7, "Float", 0.7, "Float", 1)
DllCall(glVertex2f, "Float", KeyWW, "Float", 9.6)
DllCall(glVertex2f, "Float", 0, "Float", 9.6)
DllCall(glVertex2f, "Float", 0, "Float", 9.6)
DllCall(glVertex2f, "Float", KeyWW, "Float", 9.6)
DllCall(glVertex2f, "Float", KeyWW-0.4, "Float", 9.7)
DllCall(glVertex2f, "Float", 0.4, "Float", 9.7)
DllCall(glEnd)
DllCall(glColor4f, "Float", 0, "Float", 0, "Float", 0, "Float", 1)
DllCall(glBegin, "UInt", GL_LINE_LOOP)
DllCall(glVertex2f, "Float", 0, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 9.6)
DllCall(glVertex2f, "Float", KeyWW-0.4, "Float", 9.7)
DllCall(glVertex2f, "Float", 0.4, "Float", 9.7)
DllCall(glVertex2f, "Float", 0, "Float", 9.6)
DllCall(glEnd)
DllCall(glTranslatef, "Float", KeyWW, "Float", 0, "Float", 0)
DllCall(glEndList)

DllCall(glNewList, "UInt", List+4, "UInt", GL_COMPILE)
DllCall(glTranslatef, "Float", KeyWW, "Float", 0, "Float", 0)
DllCall(glBegin, "UInt", GL_QUADS)
DllCall(glColor4f, "Float", 0, "Float", 0, "Float", 0, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 10/4*2.5)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 10/4*2.5)
DllCall(glColor4f, "Float", 0.1, "Float", 0.1, "Float", 0.1, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 0.5)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 0.5)
DllCall(glColor4f, "Float", 0.25, "Float", 0.25, "Float", 0.25, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 10/4*2.0)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 10/4*2.0)
DllCall(glColor4f, "Float", 0.1, "Float", 0.1, "Float", 0.1, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 0.5)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 0.5)
DllCall(glColor4f, "Float", 0.25, "Float", 0.25, "Float", 0.25, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 0)
DllCall(glColor4f, "Float", 0.15, "Float", 0.15, "Float", 0.15, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 10/4*2.0)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 10/4*2.0)
DllCall(glColor4f, "Float", 0.1, "Float", 0.1, "Float", 0.1, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 10/4*2.5)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 10/4*2.5)
DllCall(glEnd)
DllCall(glEndList)

PointSize := 1
DllCall(glNewList, "UInt", List+5, "UInt", GL_COMPILE)
DllCall(glEnable, "UInt", GL_BLEND)
DllCall(glBegin, "UInt", GL_TRIANGLES)
DllCall(glColor4f, "Float", 1, "Float", 0, "Float", 0, "Float", 1)
DllCall(glVertex2f, "Float", 0, "Float", 0)
DllCall(glColor4f, "Float", 1, "Float", 0, "Float", 0, "Float", 0)
DllCall(glVertex2f, "Float", 0, "Float", PointSize)
DllCall(glVertex2f, "Float", Sin(10.0531)*PointSize, "Float", -(Cos(10.0531)*PointSize))
DllCall(glEnd)
DllCall(glDisable, "UInt", GL_BLEND)
DllCall(glEndList)

FontOut := DllCall(glGenLists, "UInt", charR)
FontIn := DllCall(glGenLists, "UInt", charR)
hFont := DllCall("gdi32\CreateFont" AW
	, "Int"  , -1
	, "Int"  , 0
	, "Int"  , 0
	, "Int"  , 0
	, "Int"  , 800
	, "UInt", 0
	, "UInt", 0
	, "UInt", 0
	, "UInt", 0
	, "UInt", 4
	, "UInt", 0
	, "UInt", 4
	, "UInt", 0
	, "Ptr"  , 0
	, "Ptr")
hOFont := DllCall("gdi32\SelectObject", "Ptr", hDC, "Ptr", hFont, "Ptr")
VarSetCapacity(gmf, charR*24, 0)	; GLYPHMETRICSFLOAT struct
DllCall("opengl32\wglUseFontOutlines" AW
	, "Ptr"  , hDC
	, "UInt", charL
	, "UInt", charR
	, "UInt", FontOut
	, "Float", 0
	, "Float", 0.2
	, "Int"  , 0
	, "Ptr"  , &gmf)
DllCall("opengl32\wglUseFontOutlines" AW
	, "Ptr"  , hDC
	, "UInt", charL
	, "UInt", charR
	, "UInt", FontIn
	, "Float", 0
	, "Float", 0.2
	, "Int"  , 1
	, "Ptr"  , 0)
; TODO: find current monitor, compare X and Y against current monitor's size, adjust X Y as necessary
Gui, 2:Show, Hide w%KbdW% h%KbdH%, Virtual keyboard
SetWndPos(hWnd2, KbdX, KbdY, KbdW, KbdH)
Gui, 2:Show
GetClientSz(hWnd2, KbdCW, KbdCH)
;Return
;================================================================
UpdateOpenGL:
Critical
;t:=A_TickCount
DllCall(glClear, "UInt", 0x4000)					; GL_COLOR_BUFFER_BIT
DllCall(glViewport, "Int", 0, "Int", 0, "Int", KbdCW, "Int", KbdCH)
DllCall(glMatrixMode, "UInt", 0x1701)			; GL_PROJECTION
DllCall(glLoadIdentity)
DllCall(glOrtho, "Double", 0, "Double", 100, "Double", 10, "Double", 0, "Double", -1, "Double", 1)
DllCall(glMatrixMode, "UInt", 0x1700)			; GL_MODELVIEW
DllCall(glLoadIdentity)
Index := 1, cOctave := 1
Loop, % NumKeys
	{
	If Index in 1,3,5,7,8,10,12	; White keys
		{
		DllCall(glCallList, "UInt", ((KeyI%A_Index%down) ? List+3 : List+1))
		VK := GetKeyVK(Format("sc{:x}", MKey%A_Index%))
		If VK between %charL% and %charH%
			{
			co := VK-charL	; character offset in the font lists
			DllCall(glPushMatrix)
			DllCall(glTranslatef, "Float", -KeyW8, "Float", 9, "Float", 0)
			DllCall(glScalef, "Float", 3, "Float", -3, "Float",  1)
			DllCall(glPushMatrix)
			If (Index = 8 && cOctave = Octave)
				DllCall(glColor4f, "Float", 0.6, "Float", 0.6, "Float", 0.6, "Float", 0.9)		; RGBA
			Else DllCall(glColor4f, "Float", 0.6, "Float", 0.6, "Float", 0.6, "Float", 0.9)	; RGBA
			DllCall(glEnable, "UInt", 0x0BE2)		; GL_BLEND
			DllCall(glEnable, "UInt", 0x0B20)		; GL_LINE_SMOOTH
			DllCall(glCallList, "UInt", FontOut+co)
			DllCall(glDisable, "UInt", 0x0B20)	; GL_LINE_SMOOTH
			DllCall(glDisable, "UInt", 0x0BE2)	; GL_BLEND
			DllCall(glPopMatrix)
			If (Index = 8 && cOctave = Octave)
				DllCall(glColor4f, "Float", 1, "Float", 0.3, "Float", 0.8, "Float", 1)		; RGBA
			Else DllCall(glColor4f, "Float", 0.8, "Float", 0.8, "Float", 0.8, "Float", 1)	; RGBA
			DllCall(glCallList, "UInt", FontIn+co)
			DllCall(glPopMatrix)
			}
		}
	Index++
	if Index > 12
		{
		Index := 1
		cOctave--
		}
	}
DllCall(glLoadIdentity)
Index := 1
Loop, % NumKeys
	{
	If Index in 2,4,6,9,11	; Black keys
		DllCall(glCallList, "UInt", ((KeyI%A_Index%down) ? List+4 : List+2))
	If Index in 6,11
		DllCall(glTranslatef, "Float", KeyWW, "Float", 0, "Float", 0)
	Index++
	If Index > 12
		Index := 1
	}
DllCall(SwapBuffers, "Ptr", hDC)
;outputdebug, % "redraw " A_TickCount-t
Return
;================================================================
WndProc(hwnd, msg, wP, lP)
{
Global
If (msg=0xF)	; WM_PAINT
;	GoSub UpdateOpenGL	; makes older/weaker machines hang with 100% CPU usage
	SetTimer, UpdateOpenGL, -0
Return DllCall("user32\CallWindowProc" AW, "Ptr", hWP, "Ptr", hwnd, "UInt", msg, "Ptr", wP, "Ptr", lP)
}
;================================================================
PlayTone(wParam, lParam)
{
Global
Local cTone, sc, i
sc := (lParam>>16)&0xFF
If (Key%sc% && !Key%sc%down)
	{
	cTone := (Key%sc% + 52) + ((Octave - 1) * 12)
	GuiControl, Focus, Focusbutton
	DllCall(midiOutShortMsg, "Ptr", hMidiOut, "UInt", (Velocity<<16) + (cTone<<8) + Channel+143)
	KeyIndex := Key%sc%
	Key%sc%down := KeyI%KeyIndex%down := 1
;	Gosub UpdateOpenGL
	SetTimer, UpdateOpenGL, -0
	Return 0
	}
Return
}
;================================================================
ReleaseTone(wParam, lParam)
{
Global
Local cTone, sc
sc := (lParam>>16)&0xFF
If Key%sc%down
	{
	KeyIndex := Key%sc%
	Key%sc%down := KeyI%KeyIndex%down := 0
	cTone := (Key%sc% + 52) + ((Octave - 1) * 12)
;	DllCall(midiOutShortMsg, "Ptr", hMidiOut, "UInt", (Velocity<<16) + (cTone<<8) + Channel+127)
	DllCall(midiOutShortMsg, "Ptr", hMidiOut, "UInt", (cTone<<8) + Channel+127)	; no release velocity
;	Gosub UpdateOpenGL
	SetTimer, UpdateOpenGL, -0
	Return 0
	}
Return
}
;================================================================
MouseClick(wParam, lParam, msg, handle)
{
Global
If (DrawMode && handle=hWnd2)
	{
	MouseClick := 0
	MouseX := (lParam & 0xFFFF) / KbdCW * 100
	MouseY := (lParam >> 16) / KbdCH * 10
	CalcXPos := KeyWW - (KeyBW / 2)
	Index := 1
	Loop, % NumKeys
		{
		If Index in 2,4,6,9,11
			{
			If (MouseX < (CalcXPos + KeyBW)) && (MouseX > CalcXPos) && (MouseY < 10/4*2.5)
				{
				MouseClick := A_Index
				Break
				}
			CalcXPos := CalcXPos + KeyWW
			}
		If Index in 6,11
			CalcXPos := CalcXPos + KeyWW
		Index++
		If Index > 12
			Index := 1
		}
	If !MouseClick
		{
		CalcXPos := 0
		Index := 1
		Loop, % NumKeys
			{
			If Index in 1,3,5,7,8,10,12
				{
				If (MouseX > CalcXPos) && (MouseX < (CalcXPos + KeyWW))
					{
					MouseClick := A_Index
					Break
					}
				CalcXPos := CalcXPos + KeyWW
				}
			Index++
			If Index > 12
				Index := 1
			}
		}
	PlayTone(0, MKey%MouseClick%<<16)
	}
Return
}
;================================================================
MouseRelease(wParam, lParam, msg, handle)
{
Global
ReleaseTone(0, MKey%MouseClick%<<16)
MouseClick := 0
Return
}
;================================================================
MWheel(wP, lP)
{
Global hWnd, hVol, hVel, Volume, Velocity
Critical
x := lP&0xFFFF, y := (lP>>16)&0xFFFF
SetFormat, IntegerFast, H
hHover := DllCall("user32\WindowFromPoint", "Int", x, "Int", y, "Ptr")
hF := DllCall("user32\GetFocus", "Ptr")
SetFormat, IntegerFast, D
dt := (wP>>16)&0xFFFF > 0x7FFF ? "+1" : "+-1"
If (hHover=hVol)
	{
	GuiControl,, Vol, % dt
	GoSub ChooseVol
	Return 0
	}
Else If (hHover=hVel)
	{
	GuiControl,, Vel, % dt
	GoSub ChooseVel
	Return 0
	}
Else
	{
;	1=GA_PARENT, 2=GA_ROOT, 3=GA_ROOTOWNER
	hA := DllCall("user32\GetAncestor", "Ptr", hHover, "UInt", 1, "Ptr")
	If (hA != hWnd)
		Return 0	; if not zero, it will send wheel msg to focused control regardless of what is hovered
	If (hF != hHover)
		DllCall("user32\SetFocus", "Ptr", hHover)
	SendMessage, 0x20A, %wP%, %lP%,, ahk_id %hHover%
	Return 0
	}
}
;================================================================
HideKeys(wP, lP, msg, hwnd)
{
Global
If (hwnd=hWnd2)
	GoSub 2GuiClose
}
;================================================================
#include %A_ScriptDir%\LayoutList.ahk
