LayoutList(ByRef listH)
{
Local
key := "System\CurrentControlSet\Control\Keyboard Layouts", currKLID, currHKL
DllCall("GetKeyboardLayoutName", "Str", currKLID:="00000000")
currHKL := DllCall("GetKeyboardLayout", "UInt", 0, "Ptr")
if count := DllCall("GetKeyboardLayoutList", "UInt", 0, "Ptr", 0)
	{
	VarSetCapacity(hklbuf, count*A_PtrSize, 0)
	if count := DllCall("GetKeyboardLayoutList", "UInt", count, "UPtr", &hklbuf)
		Loop, %count%
			instHKL .= NumGet(hklbuf, A_PtrSize*(A_Index-1), "Ptr") ","
	StringTrimRight, instHKL, instHKL, 1
	}
Loop, HKLM, %key%, 2
	{
	KLID := A_LoopRegName
	RegRead, f, HKLM, %key%\%KLID%, Layout file
	RegRead, name, HKLM, %key%\%KLID%, Layout text
	SplitPath, f, n, d
	If (n && !d)
		f := A_WinDir "\System32\" n
	If (!FileExist(f) OR !n)
		Continue
	HKL := DllCall("user32\LoadKeyboardLayout" AW
		, "Str", KLID
		, "UInt", 0x82 ; KLF_NOTELLSHELL/SUBSTITUTE_OK
		, "Ptr")
	if HKL not in %instHKL%
		DllCall("user32\UnloadKeyboardLayout", "Ptr", HKL)
	list .= name "|" HKL "`n"
	}
If !DllCall("ActivateKeyboardLayout", "Ptr", currHKL, "UInt", 0)
	OutputDebug, Failed to activate old keyboard layout
StringTrimRight, list, list, 1
Sort, list
Loop, Parse, list, `n, `r
	{
	StringSplit, v, A_LoopField, |
	listN .= v1 "|", listH .= v2 "|"
	}
StringTrimRight, listN, listN, 1
StringTrimRight, listH, listH, 1
Return listN
}
;================================================================
GetChar(SC, HKL)
{
Static ks, buf, sz:=10, spec := "
	(LTrim
	8=Backspace=0x2190
	9=Tab=0x21B9
	13=Enter=0x21B5
	16=Shift=0x21E7
	17=Ctrl
	18=Alt
	20=Caps
	32=Space
	241=LWin=0x229E
	234=RWin=0x229E
	249=Apps=0x2630
	160=LShift=0x21E7
	161=RShift=0x21E7
	162=LCtrl
	163=RCtrl
	164=Alt
	165=AltGr
	)"
VK := DllCall("MapVirtualKeyEx"
	, "UInt", SC
	, "UInt", 1						; MAPVK_VSC_TO_VK=1
	, "Ptr" , HKL
	, "UInt") & 0xFFFF
If VK in 8,9,13,16,17,18,20,32,241,234,249,160,161,162,163,164,165
	{
	Loop, Parse, spec, `n, `r
		If InStr(A_LoopField, VK "=")
			{
			StringSplit, s, A_LoopField, =
			n := s3 ? Chr(s3) : s2 ? s2 : ""
			Return n
			}
	Return ""
	}
VarSetCapacity(ks, 256, 0), VarSetCapacity(buf, 2*sz, 0)
Loop
	n := DllCall("ToUnicodeEx"
		, "UInt", VK
		, "UInt", SC
		, "Ptr"  , &ks
		, "Ptr"  , &buf
		, "Int"  , sz
		, "UInt", 0
		, "Ptr"  , HKL)
Until n>=0
c := StrGet(&buf, n, "UTF-16")
StringUpper, c, c
Return, c
}
